#include <stdio.h>
#include <cctype>
#include <inttypes.h>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

/*<--------------------------------------------------------------------------->*/

const int MAX_N = 5010;
const int MAX_Q = 1000100;

int arr[MAX_N][MAX_N];
int arr1[MAX_N][MAX_N];
int xpr[MAX_N];
int xbpr[MAX_N];
int ypr[MAX_N];
int ybpr[MAX_N];

int ax[MAX_Q];
int bx[MAX_Q];
int cx[MAX_Q];
int dx[MAX_Q];

char str[MAX_Q];

void fill_arr(int h, int w)
{
    int val = 0;
    for (int x = 0; x < h; ++x)
        for (int y = 0; y < w; ++y)
            arr[x][y] = val++;
}

void fill_arr1(int h, int w)
{
    for (int x = 0; x < h; ++x)
        for (int y = 0; y < w; ++y)
            arr1[x][y] = arr[xpr[x]][ypr[y]];
}

int64_t pw(int a, int pw)
{
    int64_t ans = 1;
    while (pw--)
        ans *= a;
    return ans;
}

int64_t count_ans(int h, int w)
{
    const int64_t MOD = 1e9 + 7;
    int64_t x_pw, y_pw;
    x_pw = 1;
    int64_t ans = 0;
    for (int x = 0; x < h; ++x)
    {
        y_pw = 1;
        for (int y = 0; y < w; ++y)
            ans = (ans + ((arr1[x][y] * x_pw) % MOD) * y_pw) % MOD,
            y_pw = (y_pw * 19) % MOD;
        x_pw = (x_pw * 17) % MOD;
    }
    return ans;
}

void fill_up(int* m, int sz)
{
    for (int i = 0; i < sz; ++i)
        m[i] = i;
}

void fill_xx(int* m, int mod, int n)
{
    int i;
    scanf("%d", &i);
    for (int x = 0; x < i; ++x)
        scanf("%d", &m[x]);
    for (; i < n; ++i)
        m[i] = (10007 * m[i-2] + 10009 * m[i-1] + 87277) % mod;
}

inline
void swap_perms(int* it, int* bk, int x1, int x2)
{
    iter_swap(bk + it[x1], bk + it[x2]);
    iter_swap(it + x1, it + x2);
}

inline
void swap_elems(int x1, int y1, int x2, int y2)
{
    swap(arr[xbpr[x1]][ybpr[y1]], arr[xbpr[x2]][ybpr[y2]]);
}

void solve()
{
    int h, w, n;
    scanf("%d%d%d", &h, &w, &n);
    scanf("%s", str);

    fill_arr(h, w);
    fill_up(xpr, h);
    fill_up(xbpr, h);
    fill_up(ypr, w);
    fill_up(ybpr, w);
    fill_xx(ax, h, n);
    fill_xx(bx, w, n);
    fill_xx(cx, h, n);
    fill_xx(dx, w, n);

    for (int i = 0; i < n; ++i)
    {
             if (str[i] == 'c') swap_perms(ypr, ybpr, bx[i], dx[i]);
        else if (str[i] == 'r') swap_perms(xpr, xbpr, ax[i], cx[i]);
        else swap_elems(ax[i], bx[i], cx[i], dx[i]);
    }

    fill_arr1(h, w);

    printf("%lld", count_ans(h, w));
}

/*<--------------------------------------------------------------------------->*/

//#define LOCAL

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
