# include <bits/stdc++.h>

using namespace std;

typedef long long ll;

# define pll pair < ll, ll >
# define mp make_pair
# define pb push_back
# define fi first
# define se second

const ll maxn = (ll)1e5;
const ll MAGIC = (ll)1e13;
const ll linf = (ll)1e18;

ll n, m, q;
vector < vector < char > > a;
vector < vector < ll > > up, dn, le, ri, pc[27], pr[27];

void calcd(){
    for(ll i = 1; i <= n; ++i){
        for(ll j = 1; j <= n; ++j){
            pc[a[i][j] - 'a'][i].pb(j);
            pr[a[i][j] - 'a'][j].pb(i);
        }
    }
    for(ll i = 1; i <= n; ++i){
        for(ll j = 1; j <= m; ++j){
            up[i][j] = dn[i][j] = le[i][j] = ri[i][j] = -linf;
        }
    }
    for(ll i = 2; i <= n; ++i){
        for(ll j = 2; j <= m; ++j){
            if(a[i][j] != a[i - 1][j])
                up[i][j] = 1;
            else
                up[i][j] = up[i - 1][j] + 1;
            if(a[i][j] == a[i][j - 1])
                le[i][j] = le[i][j - 1] + 1;
            else
                le[i][j] = 1;
        }
    }
    for(ll i = n - 1; i >= 1; --i){
        for(ll j = m - 1; j >= 1; --j){
            if(a[i][j] != a[i + 1][j])
                dn[i][j] = 1;
            else
                dn[i][j] = dn[i + 1][j] + 1;
            if(a[i][j] != a[i][j + 1])
                ri[i][j] = 1;
            else
                ri[i][j] = ri[i][j + 1] + 1;
        }
    }
}

ll getle(char x, ll i, ll j){
    auto &ss = pc[x - 'a'];
    if(ss.empty()) return -1;
    auto it = lower_bound(begin(ss[i]), end(ss[i]), j);
    if(it != begin(ss[i])){
        --it;
        return *it;
    }
    else{
        return -1;
    }
}

ll getri(char x, ll i, ll j){
    auto &ss = pc[x - 'a'];
    if(ss.empty()) return -1;
    auto it = upper_bound(begin(ss[i]), end(ss[i]), j);
    if(it != end(ss[i]))
        return *it;
    else
        return -1;
}

ll getup(char x, ll i, ll j){

    auto &ss = pr[x - 'a'];
    if(ss.empty()) return -1;
    auto it = lower_bound(begin(ss[j]), end(ss[j]), i);
    if(it != begin(ss[j])){
        --it;
        return *it;
    }
    else
        return -1;
}

ll getdn(char x, ll i, ll j){
    auto &ss = pr[x - 'a'];
    if(ss.empty()) return -1;
    auto it = upper_bound(begin(ss[j]), end(ss[j]), i);
    if(it != end(ss[j]))
        return *it;
    else
        return -1;
}

ll dist(pll x, pll y){
    return llabs(x.fi - y.fi) + llabs(x.se - y.se);
}

void Solve(ll i, ll j){
    vector < pair < ll, pair < pll, pll > > > ans;
    for(char t = 'a'; t <= 'z'; ++t){
        if(pc[t - 'a'][i].empty())
            continue;
        // LEFT UP
        ll id = getle(t, i, j);
        pll F = mp(i, id);
        if(id != -1 && i > 1){
            if(a[i - 1][j] == t && up[i - 1][j] > 0){
                pll S = mp(i - 1 - up[i - 1][j], j);
                ans.pb(mp(dist(F, S), mp(F, S)));
            }
            else if(a[i - 1][j] != t){
                pll S = mp(i - 1, j);
                ans.pb(mp(dist(F, S), mp(F, S)));
            }
        }
        // LEFT DOWN
        if(id != -1 && i < n){
            if(a[i + 1][j] == t && dn[i + 1][j] > 0){
                pll S = mp(i + 1 + dn[i + 1][j], j);
                ans.pb(mp(dist(F, S), mp(F, S)));
            }
            else if(a[i + 1][j] != t){
                pll S = mp(i + 1, j);
                ans.pb(mp(dist(F, S), mp(F, S)));
            }
        }
        // RIGHT UP
        id = getri(t, i, j);
        F = mp(i, id);

        if(id != -1 && i > 1){
            if(a[i - 1][j] == t && up[i - 1][j] > 0){
                pll S = mp(i - 1 - up[i - 1][j], j);
                ans.pb(mp(dist(F, S), mp(F, S)));
            }
            else if(a[i - 1][j] != t){
                pll S = mp(i - 1, j);
                ans.pb(mp(dist(F, S), mp(F, S)));
            }
        }
        // RIGHT DOWN
        if(id != -1 && i < n){
            if(a[i + 1][j] == t && dn[i + 1][j] > 0){
                pll S = mp(i + 1 + dn[i + 1][j], j);
                ans.pb(mp(dist(F, S), mp(F, S)));
            }
            else if(a[i + 1][j] != t){
                pll S = mp(i + 1, j);
                ans.pb(mp(dist(F, S), mp(F, S)));
            }
        }
    }
    sort(ans.begin(), ans.end());
    if(ans.empty())
        printf("-1\n");
    else
        printf("%lld %lld %lld %lld\n", ans[0].se.fi.fi, ans[0].se.fi.se, ans[0].se.se.fi, ans[0].se.se.se);
}

int main(){
    scanf("%lld %lld", &n, &m);
    a.resize(n + 1);
    up.resize(n + 1);
    dn.resize(n + 1);
    le.resize(n + 1);
    ri.resize(n + 1);
    for(ll i = 0; i < 26; ++i)
        pc[i].resize(m + 1), pr[i].resize(n + 1);
    for(ll i = 1; i <= n; ++i){
        a[i].resize(m + 1);
        up[i].resize(m + 1);
        dn[i].resize(m + 1);
        le[i].resize(m + 1);
        ri[i].resize(m + 1);
        for(ll j = 1; j <= m; ++j)
            scanf(" %c", &a[i][j]);
    }
    calcd();
    scanf("%lld", &q);
    while(q--){
        ll i, j;
        scanf("%lld %lld", &i, &j);
        Solve(i, j);
    }
    return 0;
}
