#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <string>

using namespace std;

char buf[500010];

int dx[4] = {0, 1, 0, -1};
int dy[4] = {-1, 0, 1, 0};

const int MAXN = 1000000;
vector<vector<int>> cl[4];
vector<string> a;
int n, m;

bool valid(int x, int y) {
	return 0 <= x && x < n && 0 <= y && y < m;
}

int get(int dir, int x, int y) {
	if (cl[dir][x][y] == -1) {
		int xx = x + dx[dir];
		int yy = y + dy[dir];

		if (valid(xx, yy)) {
			if (a[xx][yy] != a[x][y]) {
				cl[dir][x][y] = 1;
			} else {
				cl[dir][x][y] = get(dir, xx, yy) + 1;
			}
		} else {
			cl[dir][x][y] = MAXN;
		}
	}
	return cl[dir][x][y];
}


int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	scanf("%d%d", &n, &m);
	a.resize(n);
	for (int i = 0; i < n; i++) {
		scanf("%s", buf);
		a[i] = string(buf);
	}
	for (int i = 0; i < 4; i++) {
		cl[i].resize(n);
		for (int j = 0; j < n; j++) {
			cl[i][j].resize(m);
			cl[i][j].assign(m, -1);
		}
	}

	for (int d = 0; d < 4; d++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				get(d, i, j);
			}
		}
	}

	int q;
	scanf("%d", &q);
	for (int i = 0; i < q; i++) {
		int x, y;
		scanf("%d%d", &x, &y);
		x--;
		y--;

		int mind = MAXN;
		int xa, ya, xxa, yya;

		for (int d1 = 0; d1 < 4; d1++) {
			int d2 = (d1 + 1) % 4;
			int x1 = x + dx[d1];
			int y1 = y + dy[d1];
			int x2 = x + dx[d2];
			int y2 = y + dy[d2];

			if (valid(x1, y1) && valid(x2, y2) && a[x1][y1] != a[x2][y2]) {
				int d = 2;
				if (d < mind) {
					mind = d;
					xa = x1;
					ya = y1;
					xxa = x2;
					yya = y2;
				}
			}
		}

		for (int d1 = 0; d1 < 4; d1++) {
			int d2 = (d1 + 1) % 4;
			// 1 -  , 2 -     
			int x1 = x + dx[d1];
			int y1 = y + dy[d1];
			int x2 = x + dx[d2];
			int y2 = y + dy[d2];
			if (valid(x1, y1) && valid(x2, y2)) {
				int dst2 = cl[d2][x2][y2];
				x2 = x2 + dx[d2] * dst2;
				y2 = y2 + dy[d2] * dst2;

				if (valid(x2, y2)) {
					int d = 1 + 1 + dst2;
					if (d < mind) {
						mind = d;
						xa = x1;
						ya = y1;
						xxa = x2;
						yya = y2;
					}
				}
			}

			// 2 -  , 1 -     
			x1 = x + dx[d1];
			y1 = y + dy[d1];
			x2 = x + dx[d2];
			y2 = y + dy[d2];
			if (valid(x1, y1) && valid(x2, y2)) {
				int dst1 = cl[d1][x1][y1];
				x1 = x1 + dx[d1] * dst1;
				y1 = y1 + dy[d1] * dst1;

				if (valid(x1, y1)) {
					int d = 1 + 1 + dst1;
					if (d < mind) {
						mind = d;
						xa = x1;
						ya = y1;
						xxa = x2;
						yya = y2;
					}
				}
			}
		}

		if (mind == MAXN) {
			cout << -1 << '\n';
		} else {
			cout << xa + 1 << " " << ya + 1 << " " << xxa + 1 << " " << yya + 1 << '\n';
		}
	}

	return 0;
}