#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <set>
#include <string>

using namespace std;

unordered_map < int, int > all, fin;
vector < int > ans, ls, pw;
vector < vector < int > > dna;
const int p = 239;

unordered_set < int > ln;
unordered_map < int, unordered_map < int, unordered_set < int > > > wt;

int ghs(int i, int l, int r) {
	return dna[i][r + 1] - dna[i][l] * pw[r - l + 1];
}

void push(int i) {
	for (int x : ln) {
		if (ls[i] + x > dna[i].size() - 1)
			continue;
		auto y = ghs(i, ls[i], ls[i] + x - 1);
		wt[x][y].insert(i);
	}
	return;
}

void depush(int i) {
	for (int x : ln) {
		if (ls[i] + x > dna[i].size() - 1)
			continue;
		auto y = ghs(i, ls[i], ls[i] + x - 1);
		wt[x][y].erase(i);
	}
	return;
}

void dfs(int i, int n) {
	if (n == dna[i].size() - 1) {
		ans.push_back(i);
		return;
	}
	int l = 0, r = dna[i].size() - 1 - n + 1;
	while (l != r - 1) {
		int m = (l + r) / 2;
		auto x = ghs(i, n, n + m - 1);
		if (all[x] > 0)
			l = m;
		else
			r = m;
	}
	if (!l) {
		push(i);
		return;
	}
	auto x = ghs(i, n, n + l - 1);
	if (all[x] == 1 && fin[x]) {
		ls[i] += l;
		depush(i);
		dfs(i, n + l);
	}
	else
		push(i);
}

int main() {
	ios_base::sync_with_stdio(false);
	pw.resize((int)1e6 + 1, 1);
	for (int i = 1; i < pw.size(); i++)
		pw[i] = pw[i - 1] * p;
	int n;
	cin >> n;
	int k = 0;
	vector<int> back(n);
	int cnt = 0;
	vector < int > ch(n, 0);
	for (int i = 0; i < n; i++) {
		ans.clear();
		dna.push_back(vector<int>());
		ls.push_back(0);
		char c;
		cin >> c;
		if (c == '?') {
			ch[i] = 1;
			cnt++;
			back[i] = cnt;
			string s;
			cin >> s;
			for (int i = 0; i < k; i++)
				s.push_back(s[i]);
			s = s.substr(k, s.length() - k);
			dna[i].resize(s.length() + 1, 0);
			for (int j = 1; j <= s.length(); j++)
				dna[i][j] = dna[i][j - 1] * p + s[j - 1];
			dfs(i, ls[i]);
		}
		else {
			string s;
			cin >> s;
			for (int i = 0; i < k; i++)
				s.push_back(s[i]);
			s = s.substr(k, s.length() - k);
			vector < int > cur(s.length() + 1, 0);
			for (int j = 1; j <= s.length(); j++)
				cur[j] = cur[j - 1] * p + s[j - 1];
			for (int x : cur)
				all[x]++;
			fin[cur.back()] = 1;
			if (ln.find(s.length()) == ln.end()) {
				ln.insert(s.length());
				for (int j = 0; j < i; j++) {
					if (ch[j])
						dfs(j, ls[j]);
				}
			}
			else {
				vector < int > st;
				for (auto now : wt[s.length()][cur.back()])
					st.push_back(now);
				for (int now : st)
					dfs(now, ls[now]);
			}
		}
		k = ans.size();
		cout << ans.size() << ' ';
		for (int x : ans)
			cout << back[x] << ' ';
	}
	return 0;
}

