#include <iostream>
#include <vector>

using namespace std;

const int maxn = 2e6;

string f[maxn];
vector<int> d[4][maxn];

int step[4][2] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}}; // TODO check
int n, m;

bool inbounds(int a, int b)
{
    return a >= 0 && a < n && b >= 0 && b < m;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> f[i];
        d[0][i].resize(m);
        d[1][i].resize(m);
        d[2][i].resize(m);
        d[3][i].resize(m);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            d[0][i][j] = 1;
            d[1][i][j] = 1;
            if (i != 0) {
                d[0][i][j] += (f[i][j] == f[i-1][j] ? d[0][i-1][j] : 0);
            }
            if (j != 0) {
                d[1][i][j] += (f[i][j] == f[i][j-1] ? d[1][i][j-1] : 0);
            }
        }
    }
    for (int i = n; i--; ) {
        for (int j = m; j--; ) {
            d[2][i][j] = 1;
            d[3][i][j] = 1;
            if (i != n-1) {
                d[2][i][j] += (f[i][j] == f[i+1][j] ? d[2][i+1][j] : 0);
            }
            if (j != m-1) {
                d[3][i][j] += (f[i][j] == f[i][j+1] ? d[3][i][j+1] : 0);
            }
        }
    }
    /*for (int dir = 0; dir < 4; ++dir) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                cout << d[dir][i][j] << ' ';
            }
            cout << '\n';
        }
        cout << '\n';
    }*/
    int q;
    cin >> q;
    for (int w = 0; w < q; ++w) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        int u[4];
        u[0] = a;
        u[1] = b;
        u[2] = n-a-1;
        u[3] = m-b-1;
        char prev = 'A';
        int di1 = -1, di2 = -1;
        for (int dir = 0; dir < 4; ++dir) {
            if (inbounds(a+step[dir][0], b+step[dir][1])) {
                char e = f[a+step[dir][0]][b+step[dir][1]];
                if (prev == 'A') {
                    prev = e;
                    di1 = dir;
                } else {
                    if (prev != e) {
                        di2 = dir;
                        break;
                    }
                }
            }
        }
        if (di2 != -1) {
            cout << a+step[di1][0]+1 << ' ' << b+step[di1][1]+1 << ' ' << a+step[di2][0]+1 << ' ' << b+step[di2][1]+1 << '\n';
            continue;
        }
        int mid = -1, le;
        for (int dir = 0; dir < 4; ++dir) {
            if (inbounds(a+step[dir][0], b+step[dir][1])) {
                if (d[dir][a+step[dir][0]][b+step[dir][1]] < u[dir]) {
                    if (mid == -1 || le > d[dir][a+step[dir][0]][b+step[dir][1]]) {
                        mid = dir;
                        le = d[dir][a+step[dir][0]][b+step[dir][1]];
                    }
                }
            }
        }
        if (mid == -1) {
            cout << "-1\n";
            continue;
        }
        cout << a+(le+1)*step[mid][0]+1 << ' ' <<
            b+(le+1)*step[mid][1]+1 << ' ';
        int dir1 = (mid+4-1)%4, dir2 = (mid+4+1)%4;
        if (inbounds(a+step[dir1][0], b+step[dir1][1])) {
            cout << a+step[dir1][0]+1 << ' ' << b+step[dir1][1]+1 << '\n';
        } else {
            cout << a+step[dir2][0]+1 << ' ' << b+step[dir2][1]+1 << '\n';
        }
    }
    return 0;
}
