#include <bits/stdc++.h>

using std::cerr;
using std::cin;
using std::cout;

using std::abs;
using std::min;
using std::max;
using std::swap;

using std::map;
using std::pair;
using std::set;
using std::string;
using std::vector;

using ll = long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) { \
    vector<string> _v;\
    std::stringstream _ss(#as);\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while(count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(),as);\
}
#else
#define dbg(as...)
#endif // LOCAL

template<typename T>
void err(vector<string>::iterator it, T a) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, a);
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << ", ";
    err(++it, as...);
}

struct init{
    init() {
        cin.tie(0);
        std::iostream::sync_with_stdio(0);
        cerr << std::fixed << std::setprecision(10);
        cout << std::fixed << std::setprecision(10);
        srand(300);
    }
    ~init() {
        cerr << "Time : " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
    }
} init;

struct kal{
    int x, y, c;
    kal() {}
    kal(int _x, int _y, int _c) : x(_x), y(_y), c(_c) {}
};
struct comp{
    bool operator() (const kal & a, const kal & b) {
        return (a.x == b.x ? (a.y == b.y ? a.c < b.c : a.y < b.y) : a.x < b.x);
    }
};
int main() {
    int n, m, k;
    cin >> n >> m >> k;
    set<kal, comp> s;
    for (int i = 0; i < k; ++i) {
        int a, b;
        cin >> a >> b;
        s.insert(kal(a, b, i));
    }

    for (int i = 1; i < m; ++i) {
        auto ptr = s.begin();
        while (ptr != s.end()) {
            int a = ptr->x, b = ptr->y, j = ptr->c;
            s.erase(ptr);
            ptr = s.lower_bound(kal(b, -300, -300));
        }
    }

    int ans = 1e9 + 1, w = 0;
    for (int i = 0; i < m; ++i) {
        auto ptr = s.begin();
        int sum = 0;
        while (ptr != s.end()) {
            int a = ptr->x, b = ptr->y, j = ptr->c;
            sum += b - a;
            s.erase(ptr);
            ptr = s.lower_bound(kal(b, -300, -300));
        }
        if (ans > sum) {
            ans = sum;
            w = i + 1;
        }
    }

    cout << ans << ' ' << w << '\n';

    return 0;
}
