#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;

ll x[3];

ll calc_sum(int mask) {
	ll sum = 0;

	for (int i = 0; i < 3; i++) {
		if (mask & (1 << i)) {
			sum += x[i];
		}
	}

	return sum;
}

int get_bits(int mask) {
	int cnt = 0;
	for (int i = 0; i < 3; i++) {
		if (mask & (1 << i)) {
			cnt++;
		}
	}
	return cnt;
}

int run() {
	for (int i = 0; i < 3; i++) {
		cin >> x[i];
	}

	bool ans0 = false;
	bool ans1 = false;
	pair<int, pair<ll, ll>> a1;

	for (int mask1 = 0; mask1 < (1 << 3); mask1++) {
		for (int mask2 = 0; mask2 < (1 << 3); mask2++) {
			if (mask1 & mask2) {
				continue;
			}

			ll sum1 = calc_sum(mask1);
			ll sum2 = calc_sum(mask2);

			int rest = 3 - (get_bits(mask1) + get_bits(mask2));

			if (rest == 0) {
				if (sum1 == sum2) {
					ans0 = true;
				}
			}
			else if (rest == 1) {
				int id = -1;
				for (int i = 0; i < 3; i++) {
					if ((!(mask1 & (1 << i))) && (!(mask2 & (1 << i)))) {
						id = i;
					}
				}

				ll s = sum2 + x[id] - sum1;
				if (s % 2 == 0) {
					ll a = s / 2;
					ll b = x[id] - a;
					if (a > 0 && b > 0) {
						ans1 = true;
						a1 = { id + 1, { a, b } };
					}
				}
			}
		}
	}

	if (ans0) {
		cout << "0\n";
		return 0;
	}
	if (ans1) {
		cout << a1.first << "\n";
		cout << a1.second.first << " " << a1.second.second << "\n";
		return 0;
	}

	cout << "-1\n";

	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}