#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;

int n, m;
vector<vector<char>> a;
vector<vector<int>> l_ver, r_ver, l_hor, r_hor;

int calc(pair<int, int> &u, pair<int, int> &v) {
	if (a[u.first][u.second] == a[v.first][v.second]) {
		return -1;
	}

	return abs(u.first - v.first) + abs(u.second - v.second);
}

int run() {
	cin >> n >> m;
	a.resize(n, vector<char>(m));
	l_ver.resize(n, vector<int>(m));
	r_ver.resize(n, vector<int>(m));
	l_hor.resize(n, vector<int>(m));
	r_hor.resize(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < m; j++) {
			a[i][j] = s[j];
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int k = j;
			while (k + 1 < m && a[i][k + 1] == a[i][k]) k++;

			for (int t = j; t <= k; t++) {
				l_hor[i][t] = j;
				r_hor[i][t] = k;
			}

			j = k;
		}
	}

	for (int j = 0; j < m; j++) {
		for (int i = 0; i < n; i++) {
			int k = i;
			while (k + 1 < n && a[k][j] == a[k + 1][j]) k++;

			for (int t = i; t <= k; t++) {
				l_ver[t][j] = i;
				r_ver[t][j] = k;
			}

			i = k;
		}
	}

	int q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		int x, y;
		cin >> x >> y;
		x--; y--;

		vector<pair<int, int>> A, B;

		if (x - 1 >= 0) {
			A.push_back({ x - 1, y });
			if (l_ver[x - 1][y] - 1 >= 0) {
				A.push_back({ l_ver[x - 1][y] - 1, y });
			}
		}
		if (x + 1 < n) {
			A.push_back({ x + 1, y });
			if (r_ver[x + 1][y] + 1 < n) {
				A.push_back({ r_ver[x + 1][y] + 1, y });
			}
		}

		if (y - 1 >= 0) {
			B.push_back({ x, y - 1 });
			if (l_hor[x][y - 1] - 1 >= 0) {
				B.push_back({ x, l_hor[x][y - 1] - 1 });
			}
		}

		if (y + 1 < m) {
			B.push_back({ x, y + 1 });
			if (r_hor[x][y + 1] + 1 < m) {
				B.push_back({ x, r_hor[x][y + 1] + 1 });
			}
		}

		int best = -1;
		pair<int, int> best_a, best_b;

		for (auto a : A) {
			for (auto b : B) {
				int cur = calc(a, b);
				if (cur != -1) {
					if (best == -1 || cur < best) {
						best = cur;
						best_a = a;
						best_b = b;
					}
				}
			}
		}

		if (best == -1) {
			cout << "-1\n";
		}
		else {
			cout << best_a.first + 1 << " " << best_a.second + 1 << " " << best_b.first + 1 << " " << best_b.second + 1 << "\n";
		}
	}

	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}