#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <stdlib.h>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;
const ll MAXN = 5100;

string d[100100];
int pos[100100], cv[100100];

struct Node {
	vector<int> ph[26];
	int nx[26];
	bool isA = 0;
	Node() {
		fill(nx, nx + 26, -1);
	}
};


int cur_pos = 1;

int cur_str = 0;

vector<int> cur_ans;
Node mas[1001000];


void push(int t) {
	int v = cv[t];
	int ps = pos[t];
	while (ps < d[t].size() && mas[v].nx[d[t][ps] - 'a'] != -1) {
		v = mas[v].nx[d[t][ps] - 'a'];
		ps++;
		if (mas[v].isA) v = 0;
	}
	cv[t] = v;
	pos[t] = ps;
	if (ps == d[t].size()) {
		if (v == 0)cur_ans.push_back(t+1);
	}
	else {
		mas[v].ph[d[t][ps] - 'a'].push_back(t);
	}
}


void setGen(string &s) {

	int v = 0;
	vector<int> cur_ph;
	for (int i = 0; i < (int)s.size(); i++) {
		if (mas[v].nx[s[i] - 'a'] == -1) {
			mas[v].nx[s[i] - 'a'] = cur_pos;
			cur_pos++;
		}
		for (auto i : mas[v].ph[s[i] - 'a']) cur_ph.push_back(i);
		mas[v].ph[s[i] - 'a'].clear();
		v = mas[v].nx[s[i] - 'a'];
	}
	for (int i = 0; i < 26; i++) mas[v].nx[i] = -1;
	mas[v].isA = 1;
	for (auto i : cur_ph) push(i);
}

void setDnk(string &s) {
	d[cur_str] = s;
	pos[cur_str] = 0;
	cv[cur_str] = 0;
	push(cur_str);
	cur_str++;
}

int run() {
	int n;
	int last = 0;
	cin >> n;
	for (int i = 0; i < n; i++) {
		char type;
		cin >> type;
		cur_ans.clear();
		string s;
		cin >> s;
		last %= s.size();
		reverse(s.begin(), s.begin() + last);
		reverse(s.begin() + last, s.end());
		reverse(s.begin(), s.end());
		//cerr << s << endl;
		if (type == '+') {
			setGen(s);
		}
		else {
			setDnk(s);
		}
		cout << (last = cur_ans.size()) ;
		for (auto i : cur_ans) cout << ' ' << i;
		cout << endl;
		//cerr << cur_str << ' ' << cur_pos << endl;
	}
	//for (int i = 0; i < cur_str; i++) {
	//	cerr << pos[i] << ' '; 
	//}
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}