#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <fstream>
#include <sstream>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int maxN = 1e6 + 100;
const int maxW = 5010;
const long long MOD = 1e9 + 7;

char s[maxN];
int a[maxN], b[maxN], c[maxN], d[maxN];
int t[maxW][maxW];

long long p17[maxW], p19[maxN];

int col[maxW], row[maxW];

long long modexp(long long x, long long p)
{
	long long res = 1;
	while (p > 0)
	{
		if (p & 1)
			res = (res * x) % MOD;
		x = (x * x) % MOD;
		p /= 2LL;
	}
	return res;
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	//srand(time(NULL));

	int h, w, n;
	scanf("%d%d%d", &h, &w, &n);
	scanf("%s", s);

	long long sum = 0;

	for (long long i = 0; i < h; i++)
	{
		for (long long j = 0; j < w; j++)
		{
			t[i][j] = i * w + j;
		}
	}
	
	int k;
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		scanf("%d", &a[i]);
	}
	for (int i = k; i < n; i++)
	{
		a[i] = (10007 * a[i - 2] + 10009 * a[i - 1] + 87277) % h;
	}
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		scanf("%d", &b[i]);
	}
	for (int i = k; i < n; i++)
	{
		b[i] = (10007 * b[i - 2] + 10009 * b[i - 1] + 87277) % w;
	}
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		scanf("%d", &c[i]);
	}
	for (int i = k; i < n; i++)
	{
		c[i] = (10007 * c[i - 2] + 10009 * c[i - 1] + 87277) % h;
	}
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		scanf("%d", &d[i]);
	}
	for (int i = k; i < n; i++)
	{
		d[i] = (10007 * d[i - 2] + 10009 * d[i - 1] + 87277) % w;
	}

	for (int i = 0; i < h; i++)
	{
		row[i] = i;
	}
	for (int i = 0; i < w; i++)
	{
		col[i] = i;
	}


	for (int i = 0; i < n; i++)
	{
		if (s[i] == 'c')
		{
			swap(col[b[i]], col[d[i]]);
		}
		else if (s[i] == 'r')
		{
			swap(row[a[i]], row[c[i]]);
		}
		else
		{
			swap(t[row[a[i]]][col[b[i]]], t[row[c[i]]][col[d[i]]]);
		}
	}
	p17[0] = p19[0] = 1;
	for (int i = 1; i < maxW; i++)
	{
		p17[i] = (p17[i - 1] * 17LL) % MOD;
		p19[i] = (p19[i - 1] * 19LL) % MOD;
	}

	for (long long i = 0; i < h; i++)
	{
		for (long long j = 0; j < w; j++)
		{
			long long val = t[row[i]][col[j]];
			sum += ((((val * p17[i])) % MOD) * p19[j]) % MOD;
			sum %= MOD;
		}
	}

	cout << sum;
	

	return 0;
}