#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <string>
#include <string>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

struct cond {
	int first, second;
	int x, y;
	bool operator < (cond b) const {
		return (first == b.first ? second < b.second : first < b.first);
	}
	cond operator + (int xx) const {
		return{ first + xx, second, x, y };
	}
};

vector<string> A;
vector<vector<int> > PL[26], PR[26], PU[26], PD[26];
vector<vector<vector<cond> > > GR, GC;

vector<cond> Q;

int solve() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	A.resize(n);
	GR.resize(n);
	GC.resize(n);

	for (int i = 0; i < 26; i++) {
		PL[i].resize(n);
		PR[i].resize(n);
		PU[i].resize(n);
		PD[i].resize(n);
		for (int j = 0; j < n; j++) {
			PL[i][j].resize(m);
			PR[i][j].resize(m);
			PD[i][j].resize(m);
			PU[i][j].resize(m);
		}
	}

	for (int i = 0; i < n; i++) {
		GR[i].resize(m);
		GC[i].resize(m);
	}

	for (int i = 0; i < n; i++) {
		cin >> A[i];
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int t = 0; t < 26; t++) {
				if (j > 0) {
					if (A[i][j - 1] - 'a' == t)
						PL[t][i][j] = 1;// { 1, t, i, j - 1 };
					else {
						PL[t][i][j] = PL[t][i][j - 1] + 1;
					}
				} else {
					PL[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}

				if (i > 0) {
					if (A[i - 1][j] - 'a' == t)
						PU[t][i][j] = 1;// { 1, t, i - 1, j };
					else
						PU[t][i][j] = PU[t][i - 1][j] + 1;
				} else {
					PU[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}
			}
		}
	}

	for (int i = n - 1; i >= 0; i--) {
		for (int j = m - 1; j >= 0; j--) {
			for (int t = 0; t < 26; t++) {
				if (j + 1 < m) {
					if (A[i][j + 1] - 'a' == t) {
						PR[t][i][j] = 1;// { 1, t, i, j + 1 };
					} else {
						PR[t][i][j] = PR[t][i][j + 1] + 1;
					}
				} else {
					PR[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}

				if (i + 1 < n) {
					if (A[i + 1][j] - 'a' == t) {
						PD[t][i][j] = 1;// { 1, t, i + 1, j };
					} else {
						PD[t][i][j] = PD[t][i + 1][j] + 1;
					}
				} else {
					PD[t][i][j] = (int)1e9;// { (int)1e9, t, 0, 0 };
				}
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {

			Q.resize(0);

			for (int t = 0; t < 26; t++) {
				Q.push_back({ PL[t][i][j], t, i, j - PL[t][i][j] });
				Q.push_back({ PR[t][i][j], t, i, j + PR[t][i][j] });
			}

			sort(Q.begin(), Q.end());

			for (int ii = 0; ii < (int)Q.size(); ii++) {
				if (ii == 0 || Q[ii].second != Q[ii - 1].second)
					GR[i][j].push_back(Q[ii]);

				if ((int)GR[i][j].size() == 2)
					break;
			}
		}
	}


	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			Q.resize(0);

			for (int t = 0; t < 26; t++) {
				Q.push_back({ PU[t][i][j], t, i - PU[t][i][j], j });
				Q.push_back({ PD[t][i][j], t, i + PD[t][i][j], j });
			}

			sort(Q.begin(), Q.end());

			for (int ii = 0; ii < (int)Q.size(); ii++) {
				if (ii == 0 || Q[ii].second != Q[ii - 1].second)
					GC[i][j].push_back(Q[ii]);

				if ((int)GC[i][j].size() == 2)
					break;
			}
		}
	}

	int q;
	cin >> q;
	while (q--) {
		int i, j;
		cin >> i >> j;
		i--, j--;

		int c = A[i][j] - 'a';
		int ans = (int)1e9;
		pair<int, int> X, Y;

		for (auto c1 : GC[i][j]) {
			for (auto c2 : GR[i][j]) {
				if (c1.second != c2.second) {
					if (ans > c1.first + c2.first) {
						ans = c1.first + c2.first;
						X = { c1.x, c1.y };
						Y = { c2.x, c2.y };
					}
				}
			}
		}
		if (ans == (int)1e9)
			cout << -1 << "\n";
		else
			cout << X.first + 1 << " " << X.second + 1 << " " << Y.first + 1 << " " << Y.second + 1 << "\n";
	}

	return 0;
}