#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
int n, m;
int dx[] = {1, 0, -1, 0};
int dy[] = {0, -1, 0, 1};
bool check(int a, int b){
    return (a >= 0 && a < n && b >= 0 && b < m);
}
int min(int a, int b){
    if(a < b) return a;
    return b;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
	cin >> n >> m;
	vector<vector<short> > a(n, vector<short>(m));
	for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            char c;
            cin >> c;
            a[i][j] = c - 'a';
        }
	}
	vector<vector<vector<int> > >  left(26, vector<vector<int> >(n, vector<int>(m, 1e7))), right(26, vector<vector<int> > (n, vector<int>(m, 1e7))), up(26, vector<vector<int> > (n, vector<int>(m, 1e7))), down(26, vector<vector<int> >(n, vector<int>(m, 1e7)));
	for(int i = 0; i < 26; i++)
        for(int j = 0; j < n; j++)
            for(int k = 0; k < m; k++)
                left[i][j][k] = right[i][j][k] = up[i][j][k] = down[i][j][k] = 1e7;
	for(int i = 0; i < n; i++){
        for(int c = 0; c < 26; c++){
            for(int j = 1; j < m; j++){
                left[c][i][j] = (a[i][j - 1] == c) ? 1 : min(left[c][i][j], left[c][i][j - 1] + 1);
            }
        }
	}
	for(int i = 0; i < n; i++){
        for(int c = 0; c < 26; c++){
            for(int j = m - 2; j >= 0; j--){
                right[c][i][j] = (a[i][j + 1] == c) ? 1 : min(right[c][i][j], right[c][i][j + 1] + 1);
            }
        }
	}
    for(int j = 0; j < m; j++){
        for(int c = 0; c < 26; c++){
            for(int i = 1; i < n; i++){
                up[c][i][j] = (a[i - 1][j] == c) ? 1 : min(up[c][i][j], up[c][i - 1][j] + 1);
            }
        }
	}
    for(int j = 0; j < m; j++){
        for(int c = 0; c < 26; c++){
            for(int i = n - 2; i >= 0; i--){
                down[c][i][j] = (a[i + 1][j] == c) ? 1 : min(down[c][i][j], down[c][i + 1][j] + 1);
            }
        }
	}
	int q;
	cin >> q;
	for(int i = 0; i < q; i++){
        int x, y;
        cin >> x >> y;
        x--, y--;
        int x1, y1, x2, y2, ccx, ccy;
        int mindist = 1e6;
        for(int t = 0; t < 4; t++){
            if(!check(x + dx[t], y + dy[t])) continue;
            int cx = a[x + dx[t]][y + dy[t]];
            for(int cy = 0; cy < 26; cy++){
                if(cx == cy) continue;
                if(dx[t] == 0){
                    if(up[cy][x][y] + 1 < mindist){
                        x1 = x + dx[t], y1 = y + dy[t], y2 = y, x2 = x - up[cy][x][y], mindist = 1 + up[cy][x][y];
                    }
                    if(down[cy][x][y] + 1 < mindist){
                        x1 = x + dx[t], y1 = y + dy[t], y2 = y, x2 = x + down[cy][x][y], mindist = 1 + down[cy][x][y];
                    }
                }
                else{
                    if(left[cy][x][y] + 1 < mindist){
                        x1 = x + dx[t], y1 = y + dy[t], y2 = y - left[cy][x][y], x2 = x, mindist = 1 + left[cy][x][y];
                    }
                    if(right[cy][x][y] + 1 < mindist){
                        x1 = x + dx[t], y1 = y + dy[t], y2 = y + right[cy][x][y], x2 = x, mindist = 1 + right[cy][x][y];
                    }
                }
            }
        }
        if(mindist < 1e6){
            cout << x1 + 1 << ' ' << y1 + 1 << ' ' << x2 + 1 << ' ' << y2 + 1 << '\n';
        }
        else{
            cout << "-1\n";
        }
	}
}
