#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <climits>
#include <cinttypes>

using namespace std;

typedef long long i64;
typedef pair < int, int > pii;
typedef pair < int, pii > piii;
#define mp(x, y) make_pair(x, y)
#define tri(x, a, b, c) x(a, x(b, c))
#define quad(x, a, b, c, d) x(x(a, b), x(c, d))
#define mendl '\n';
const int INF = 1e9;

void ans(int a, int b, int c, int d) {
	if (a == -1)
		cout << -1;
	else
		cout << a + 1 << " " << b + 1 << " " << c + 1 << " " << d + 1;
	cout << mendl;
}

int main() {

#ifdef _DEBUG
	freopen("Text.txt", "r", stdin);
#endif

	ios::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	vector < vector < char > > board(n, vector < char >(m));
	vector < vector < int > > c_hor(n), c_vert(m);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> board[i][j];
			if (i && board[i - 1][j] != board[i][j]) {
				c_vert[j].push_back(i);
			}
			if (j && board[i][j - 1] != board[i][j]) {
				c_hor[i].push_back(j);
			}
		}
	}

	int k;
	cin >> k;

	int x, y;
	char u, d, l, r;
	vector < int >::iterator ru, rd, rl, rr;
	int riu, rid, ril, rir, minn;
	bool res;
	char nonec = 0;
	for (int tc = 0; tc < k; tc++) {
		cin >> x >> y;
		x--; y--;
		
		u = (x ? board[x - 1][y] : 0);
		d = (n - x - 1 ? board[x + 1][y] : 0);
		l = (y ? board[x][y - 1] : 0);
		r = (m - y - 1 ? board[x][y + 1] : 0);

		if (u) {
			if (r && u != r) {
				ans(x - 1, y, x, y + 1);
				continue;
			}
			else {
				if (l && u != l) {
					ans(x - 1, y, x, y - 1);
					continue;
				}
			}
		}
		if (d) {
			if (r && d != r) {
				ans(x + 1, y, x, y + 1);
				continue;
			}
			else {
				if (l && d != l) {
					ans(x + 1, y, x, y - 1);
					continue;
				}
			}
		}
		
		ru = upper_bound(c_vert[y].begin(), c_vert[y].end(), x - 1);
		rd = upper_bound(c_vert[y].begin(), c_vert[y].end(), x + 1);
		rl = upper_bound(c_hor[x].begin(), c_hor[x].end(), y - 1);
		rr = upper_bound(c_hor[x].begin(), c_hor[x].end(), y + 1);

		riu = (ru == c_vert[y].begin() ? INF : x - *(ru - 1) + 1);
		rid = (rd == c_vert[y].end() ? INF : *rd - x);
		ril = (rl == c_hor[x].begin() ? INF : y - *(rl - 1) + 1);
		rir = (rr == c_hor[x].end() ? INF : *rr - y);

		minn = quad(min, riu, rid, ril, rir);

		if (minn == INF) {
			ans(-1, 0, 0, 0);
			continue;
		}

		if (minn == riu) {
			ans(x - minn, y, x, (y ? y - 1 : y + 1));
		}
		else {
			if (minn == rid) {
				ans(x + minn, y, x, (y ? y - 1 : y + 1));
			}
			else {
				if (minn == ril) {
					ans(x, y - minn, (x ? x - 1 : x + 1), y);
				}
				else {
					ans(x, y + minn, (x ? x - 1 : x + 1), y);
				}
			}
		}

	}


	return 0;
}
