import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

/**
 * Created by orspc on 11.12.2016.
 */

/*
10 2 3
1 10
3 9
7 10


10 3 5
1 10
1 10
1 2
1 10
9 10
 */
public class TaskB {

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int k = nextInt();

        Event[] es = new Event[2 * k];
        int[] a = new int[k];
        int[] b = new int[k];
        for (int i = 0; i < k; i++) {
            a[i] = nextInt();
            b[i] = nextInt();
            es[i] = new Event(a[i], 1, i);
            es[i + k] = new Event(b[i], -1, i);
        }
        Arrays.sort(es);

        TreeSet<Integer> freeSit = new TreeSet<>();
        TreeSet<Integer> freeStand = new TreeSet<>();
        long[] time = new long[m];
        int[] sitPlaceFor = new int[k];
        int[] standPlaceFor = new int[k];
        Arrays.fill(sitPlaceFor, -1);
        Arrays.fill(standPlaceFor, -1);
        for (int i = 0; i < m; i++) {
            freeSit.add(i);
            freeStand.add(i);
        }
        freeSit.remove(0);

        for (int i = 0; i < es.length; i++) {
            Event e = es[i];

            if (e.type == -1) {
                if (sitPlaceFor[e.man] != -1) {
                    int place = sitPlaceFor[e.man];

                    freeSit.add(place);
                } else if (standPlaceFor[e.man] != -1) {
                    int place = standPlaceFor[e.man];
                    time[place] += b[e.man] - a[e.man];
                    freeStand.add(place);
                }
            } else {
                if (!freeSit.isEmpty()) {
                    int place = freeSit.pollFirst();
                    sitPlaceFor[e.man] = place;
                } else if (!freeStand.isEmpty()) {
                    int place = freeStand.pollFirst();
                    standPlaceFor[e.man] = place;
                }
            }
        }

        long minVal = Long.MAX_VALUE;
        int minIdx = -1;
        for (int i = 0; i < time.length; i++) {
            if (time[i] < minVal) {
                minIdx = i;
                minVal = time[i];
            }
        }

        out.println(minVal + " " + (minIdx + 1));
    }

    class Event implements Comparable<Event> {
        int time;
        int type;
        int man;

        public Event(int time, int type, int man) {
            this.time = time;
            this.type = type;
            this.man = man;
        }

        @Override
        public int compareTo(Event o) {
            if (time == o.time) {
                if (type == o.type) {
                    return Integer.compare(man, o.man);
                }
                return Integer.compare(type, o.type);
            }
            return Integer.compare(time, o.time);
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskB().run();
    }

}
