import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

/*
3 5 3
crf
3 0 0 0
3 0 0 1
3 0 1 1
3 1 0 2
 */

public class TaskF {
    final long MOD = (long) 1e9 + 7;
    int n;
    public void solve() throws IOException {
        int h = nextInt();
        int w = nextInt();

        int n = nextInt();

        String str = nextToken();

        long[][] arr = new long[h][w];

        for (int i = 0; i < h; i++) {
            for (int j = 0; j < w; j++) {
                arr[i][j] = i * w + j;
            }
        }

        long[] power17 = new long[h];
        long[] power19 = new long[w];

        power17[0] = 1;
        power19[0] = 1;

        int[] arr1 = new int[h];
        int[] arr2 = new int[w];

        for (int i = 1; i < h; i++) {
            power17[i] = power17[i - 1] * 17 % MOD;
            arr1[i] = i;
        }

        for (int i = 1; i < w; i++) {
            power19[i] = power19[i - 1] * 19 % MOD;
            arr2[i] = i;
        }

        int[] a = readArr();
        int[] ax = new int[n];

        for (int i = 0; i < n; i++) {
            if (i < a.length) {
                ax[i] = a[i];
            } else {
                ax[i] = (((10007 % h) * ax[i - 2] % h + (10009 % h) * (ax[i - 1] % h) + 87277 % h) % h + h) % h;
            }
        }

        int[] b = readArr();
        int[] c = readArr();
        int[] d = readArr();

        int[] bx = new int[n];

        for (int i = 0; i < n; i++) {
            if (i < b.length) {
                bx[i] = b[i];
            } else {
                bx[i] = (((10007 % w) * bx[i - 2] % w + (10009 % w) * (bx[i - 1] % w) + 87277 % w) % w + w) % w;
            }
        }

        int[] cx = new int[n];

        for (int i = 0; i < n; i++) {
            if (i < c.length) {
                cx[i] = c[i];
            } else {
                cx[i] = (((10007 % h) * cx[i - 2] % h + (10009 % h) * (cx[i - 1] % h) + 87277 % h) % h + h) % h;
            }
        }

        int[] dx = new int[n];

        for (int i = 0; i < n; i++) {
            if (i < d.length) {
                dx[i] = d[i];
            } else {
                dx[i] = (((10007 % w) * dx[i - 2] % w + (10009 % w) * (dx[i - 1] % w) + 87277 % w) % w + w) % w;
            }
        }

        for (int i = 0; i < n; i++) {
            if (str.charAt(i) == 'c') {
                int a1 = bx[i];
                int b1 = dx[i];

                int z = arr2[a1];
                arr2[a1] = arr2[b1];
                arr2[b1] = z;
            } else if (str.charAt(i) == 'r') {
                int a1 = ax[i];
                int b1 = cx[i];

                int z = arr1[a1];
                arr1[a1] = arr1[b1];
                arr1[b1] = z;
            } else {
                int a1 = ax[i];
                int b1 = bx[i];
                int a2 = cx[i];
                int b2 = dx[i];

                a1 = arr1[a1];
                b1 = arr2[b1];
                a2 = arr1[a2];
                b2 = arr2[b2];

                long z = arr[a1][b1];
                arr[a1][b1] = arr[a2][b2];
                arr[a2][b2] = z;
            }
        }

        long ans = 0;

        for (int i = 0; i < h; i++) {
            for (int j = 0; j < w; j++) {
                ans += (((arr[arr1[i]][arr2[j]] * power17[i]) % MOD) * power19[j]) % MOD;
                ans %= MOD;
            }
        }

        out.print(ans);
    }

    int[] readArr() throws IOException {
        int k = nextInt();
        int[] a = new int[k];

        for (int i = 0; i < k; i++) {
            a[i] = nextInt();
        }

        return a;
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskF().run();
    }
}
