#include <iostream>
#include <vector>
#include <set>


using namespace std;


const int STANDBY_ID = 1e6;


int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    set<int> free;
    set<pair<int, int>> out;
    vector<pair<int, int>> in;

    vector<int> sum_time;
    sum_time.reserve(m);
    for (int i = 0; i < m; i++)
    {
        free.insert(i);
        free.insert(i + STANDBY_ID);
        sum_time.push_back(0);
    }
    free.erase(m - 1);
    for (int i = 0; i < k; i++)
    {
        int a, b;
        cin >> a >> b;
        in.push_back({a, b});
    }
    int nxt = 0;
    while (nxt < in.size())
    {
        int tin = in[nxt].first;
        int tout = in[nxt].second;
        //cerr << "T: " << tin << ' ' << tout << " C: " << in.size() << endl;
        while (!out.empty() && out.begin()->first <= tin)
        {
            free.insert(out.begin()->second);
            out.erase(out.begin());
        }
        if (!free.empty())
        {
            int place = *free.begin();
            free.erase(free.begin());
            if (place >= STANDBY_ID)
            {
                sum_time[place - STANDBY_ID] += (tout - tin);
            }
            out.insert({tout, place});
        }
        nxt++;
    }
    pair<int, int> ans = {STANDBY_ID, STANDBY_ID};
    for (int i = 0; i < m; i++)
    {
        ans = min(ans, {sum_time[i], i + 1});
        //cout << i + 1 << ' ' << sum_time[i] << endl;
    }
    cout << ans.first << ' ' << ans.second << endl;
}
