#include <bits/stdc++.h>
using namespace std;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(long long i = a;i <= b; ++i)
#define fi first
#define se second

typedef long long i64;

const int A = 28;
const int N = 5e5 + 9;
const int INF = 2e9 + 9;

int n,m;

vector < vector <int> > close_horizontal [A], close_vertical [A];
vector <vector <char> > table;

void calc_string(int line, char x) {
    int num = x - 'a';
    vector <int> close_left (m + 2, INF), close_right(m + 2, INF);
    For(j, 1, m) {
        close_left[j] = close_left[j - 1];
        if(table[line][j - 1] == x)
            close_left[j] = j - 1;
    }
    for(int j = m; j >= 1; j--) {
        close_right[j] = close_right[j + 1];
        if(table[line][j + 1] == x)
            close_right[j] = j + 1;
    }
    close_horizontal[num][line].resize(m + 2);
    For(j, 1, m) {
        int &res = close_horizontal[num][line][j];
        if(abs(j - close_left[j]) < abs(j - close_right[j])) {
            res = close_left[j];
        }
        else
            res = close_right[j];
    }
}

void calc_column(int column, char x) {
    int num = x - 'a';
    vector <int> close_up (n + 2, INF), close_down (n + 2, INF);
    For(i, 1, n) {
        close_up[i] = close_up[i-1];
        if(table[i-1][column] == x)
            close_up[i] = i - 1;
    }
    for(int i = n - 1; i >= 1;i--) {
        close_down[i] = close_down[i+1];
        if(table[i+1][column] == x)
            close_down[i] = i + 1;
    }
    close_vertical[num][column].resize(n + 2);
    For(i, 1, n) {
        int &res = close_vertical[num][column][i];
        if(abs(i - close_up[i]) < abs(i - close_down[i]))
            res = close_up[i];
        else
            res = close_down[i];
    }
}

void prepare() {
    for(char x = 'a'; x <= 'z'; ++x) {
        close_horizontal[x - 'a'].resize(n + 2);
        close_vertical[x - 'a'].resize(m + 2);
        For(i, 1, n) {
            calc_string(i, x);
        }
        For(j, 1, m) {
            calc_column(j, x);
        }
    }
}

int main()
{
#ifdef HOME
    freopen("input.txt","r",stdin);
#endif // HOME
    ios::sync_with_stdio(NULL); cin.tie(NULL);
    cin >> n >> m;
    table.resize(n + 2);
    table[0].resize(m + 2);
    For(i, 1, n) {
        table[i].resize(m + 2);
        string s; cin >> s;
        For(j, 1, m) {
            table[i][j] = s[j-1];
        }
    }
    prepare();
    int Q; cin >> Q;
    int line, column;
    For(q, 1, Q) {
        cin >> line >> column;
        int ans = INF, ans_line, ans_column;
        for(char x = 'a'; x <= 'z'; ++x) {
            for(char y = 'a'; y <= 'z'; ++y) {
                if(x == y)
                    continue;
                int close_line = close_horizontal[x - 'a'][line][column];
                int close_column = close_vertical[y - 'a'][column][line];
                if(close_line == INF || close_column == INF)
                    continue;
                int cur = abs(line - close_column) + abs(column - close_line);
                if(cur < ans) {
                    ans = cur;
                    ans_line = close_line;
                    ans_column = close_column;
                }
            }
        }
        if(ans == INF)
            cout << -1;
        else
            cout << line << ' ' << ans_line << ' ' << ans_column << ' ' << column;
        cout << '\n';
    }
    return 0;
}
