#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

const int INF = 1e9;
const int CH = 8;

struct Node {
	int val, x, y;
};

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, m;
	cin >> n >> m;

	vector<string> f(n);

	for (int i = 0; i < n; i++) {
		cin >> f[i];
	}

	vector<vector<vector<Node> > > col(n, vector<vector<Node> >(m)), row(n, vector<vector<Node> >(m));

	for (int i = 0; i < n; i++) {
		vector<int> near(26, -INF);
		set<pair<int, int> > tmp;
		for (int j = 0; j < m; j++) {
			

			for (auto c : tmp) {
				if ((int)row[i][j].size() == CH) break;
				// if (c.second == f[i][j] - 'a') continue;
				row[i][j].push_back({ c.second, i, -c.first });
			}

			if (tmp.find({ -near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ -near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = max(near[f[i][j] - 'a'], j);
			tmp.insert({ -near[f[i][j] - 'a'], f[i][j] - 'a' });
		}

		near.assign(26, INF);
		tmp.clear();

		for (int j = m - 1; j >= 0; j--) {
			

			for (auto c : tmp) {
				// if (c.second == f[i][j] - 'a') continue;
				if ((int)row[i][j].size() == CH && j - row[i][j][CH - 1].y < c.first - j) break;

				if (row[i][j].empty()) {
					row[i][j].push_back({ c.second, i, c.first });
				}
				else {
					for (int k = 0; k < (int)row[i][j].size(); k++) {
						if (c.first - j < j - row[i][j][k].y) {
							row[i][j][k] = { c.second, i, c.first };
							for (int tmp = k + 1; tmp < (int)row[i][j].size(); tmp++) {
								if (row[i][j][tmp].val == c.second) {
									row[i][j].erase(row[i][j].begin() + tmp);
									break;
								}
							}
							break;
						}
						else if (row[i][j][k].val == c.second) {
							break;
						}
					}
				}
			}

			if (tmp.find({ near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = min(near[f[i][j] - 'a'], j);
			tmp.insert({ near[f[i][j] - 'a'], f[i][j] - 'a' });
		}
	}

	for (int j = 0; j < m; j++) {
		vector<int> near(26, -INF);
		set<pair<int, int> > tmp;
		for (int i = 0; i < n; i++) {
			
			for (auto c : tmp) {
				if ((int)col[i][j].size() == CH) break;
				//if (c.second == f[i][j] - 'a') continue;
				col[i][j].push_back({ c.second, -c.first, j });
			}
			if (tmp.find({ -near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ -near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = max(near[f[i][j] - 'a'], i);
			tmp.insert({ -near[f[i][j] - 'a'], f[i][j] - 'a' });

		}

		near.assign(26, INF);
		tmp.clear();

		for (int i = n - 1; i >= 0; i--) {
			
			for (auto c : tmp) {
				// if (c.second == f[i][j] - 'a') continue;
				if ((int)col[i][j].size() == CH && i - col[i][j][CH - 1].y < c.first - i) break;

				if (col[i][j].empty()) {
					col[i][j].push_back({ c.second, c.first, j });
				}
				else {
					for (int k = 0; k < (int)col[i][j].size(); k++) {
						if (c.first - i < i - col[i][j][k].y) {
							col[i][j][k] = { c.second, c.first, j };
							for (int tmp = k + 1; tmp < (int)col[i][j].size(); tmp++) {
								if (col[i][j][tmp].val == c.second) {
									col[i][j].erase(col[i][j].begin() + tmp);
									break;
								}
                            }
							break;
						}
						else if (col[i][j][k].val == c.second) {
							break;
						}
					}
				}
			}

			if (tmp.find({ near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = min(near[f[i][j] - 'a'], i);
			tmp.insert({ near[f[i][j] - 'a'], f[i][j] - 'a' });

		}
	}

	int q;
	cin >> q;

	while (q--) {
		int x, y;
		cin >> x >> y;
		x--, y--;

		int mn = INF, x1, x2, y1, y2;

		for (auto t1 : row[x][y]) {
			for (auto t2 : col[x][y]) {
				if (abs(t1.x - t2.x) + abs(t1.y - t2.y) < mn && t1.val != t2.val) {
					mn = abs(t1.x - t2.x) + abs(t1.y - t2.y);
					x1 = t1.x;
					x2 = t2.x;
					y1 = t1.y;
					y2 = t2.y;
				}
			}
		}

		if (mn == INF) {
			cout << "-1\n";
		}
		else {
			cout << x1 + 1 << " " << y1 + 1 << " " << x2 + 1 << " " << y2 + 1 << "\n";
		}
	}

	return 0;
}

