#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>

using namespace std;

const int INF = 1e9;
const int CH = 2;

struct Node {
	int dst;
	char val;
    int x, y;

	inline bool friend operator <(Node a, Node b) {
		return a.dst < b.dst || (a.dst == b.dst && a.val < b.val);
	}
};

inline int readInt() {
	int r = 0;
	char c = 0;
	while (c < 32) c = getchar();
	while (c > 32) r = r * 10 + c - '0', c = getchar();
	return r;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n, m;
	cin >> n >> m;

	vector<string> f(n);

	for (int i = 0; i < n; i++) {
		cin >> f[i];
	}

	vector<vector<set<Node> > > col(n, vector<set<Node> >(m)), row(n, vector<set<Node> >(m));
	vector<vector<vector<int> > > coltt(n, vector<vector<int> >(m, vector<int>(26, INF))), rowtt(n, vector<vector<int> >(m, vector<int>(26, INF)));

	for (int i = 0; i < n; i++) {
		vector<int> near(26, -INF);
		set<pair<int, char> > tmp;
		for (int j = 0; j < m; j++) {
			

			for (auto c : tmp) {
				if ((int)row[i][j].size() == CH) break;
				// if (c.second == f[i][j] - 'a') continue;
				row[i][j].insert({ j + c.first, c.second, i, -c.first });
				rowtt[i][j][c.second] = j + c.first;
			}

			if (tmp.find({ -near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ -near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = j;
			tmp.insert({ -near[f[i][j] - 'a'], f[i][j] - 'a' });
		}

		near.assign(26, INF);
		tmp.clear();

		for (int j = m - 1; j >= 0; j--) {

			for (auto c : tmp) {
				// if (c.second == f[i][j] - 'a') continue;
				if (rowtt[i][j][c.second] != INF && rowtt[i][j][c.second] > c.first - j) {
					row[i][j].erase({ rowtt[i][j][c.second], c.second, 0, 0 });
				}
				else if (rowtt[i][j][c.second] != INF) {
					continue;
				}
				if ((int)row[i][j].size() == CH && j - (*(--row[i][j].end())).y < c.first - j) break;

				if (row[i][j].size() > CH) rowtt[i][j][(*(--row[i][j].end())).val] = INF;
				rowtt[i][j][c.second] = c.first - j;
				row[i][j].insert({ c.first - j, c.second, i, c.first });
				if (row[i][j].size() > CH) row[i][j].erase(--row[i][j].end());
			}

			if (tmp.find({ near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = j;
			tmp.insert({ near[f[i][j] - 'a'], f[i][j] - 'a' });
		}
	}

	for (int j = 0; j < m; j++) {
		vector<int> near(26, -INF);
		set<pair<int, char> > tmp;
		for (int i = 0; i < n; i++) {
			
			for (auto c : tmp) {
				if ((int)col[i][j].size() == CH) break;
				//if (c.second == f[i][j] - 'a') continue;
				col[i][j].insert({ i + c.first, c.second, -c.first, j });
				coltt[i][j][c.second] = i + c.first;
			}
			if (tmp.find({ -near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ -near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = i;
			tmp.insert({ -near[f[i][j] - 'a'], f[i][j] - 'a' });

		}

		near.assign(26, INF);
		tmp.clear();

		for (int i = n - 1; i >= 0; i--) {
			
			for (auto c : tmp) {
				if (coltt[i][j][c.second] != INF && coltt[i][j][c.second] > c.first - i) {
					col[i][j].erase({ coltt[i][j][c.second], c.second, 0, 0 });
				}
				else if (coltt[i][j][c.second] != INF) {
					continue;
				}
				// if (c.second == f[i][j] - 'a') continue;
				if ((int)col[i][j].size() == CH && i - (*(--col[i][j].end())).y < c.first - i) break;

				if ((int)col[i][j].size() > CH) coltt[i][j][(*(--col[i][j].end())).val] = INF;
				coltt[i][j][c.second] = c.first - i;
                col[i][j].insert({ c.first - i, c.second, c.first, j });
                if ((int)col[i][j].size() > CH) col[i][j].erase(--col[i][j].end());
			}

			if (tmp.find({ near[f[i][j] - 'a'], f[i][j] - 'a' }) != tmp.end()) tmp.erase({ near[f[i][j] - 'a'], f[i][j] - 'a' });
			near[f[i][j] - 'a'] = i;
			tmp.insert({ near[f[i][j] - 'a'], f[i][j] - 'a' });

		}
	}

	int q;
	cin >> q;

	while (q--) {
		int x, y;
		cin >> x >> y;
		x--, y--;

		int mn = INF, x1, x2, y1, y2;

		for (auto t1 : row[x][y]) {
			for (auto t2 : col[x][y]) {
				if (abs(t1.x - t2.x) + abs(t1.y - t2.y) < mn && t1.val != t2.val) {
					mn = abs(t1.x - t2.x) + abs(t1.y - t2.y);
					x1 = t1.x;
					x2 = t2.x;
					y1 = t1.y;
					y2 = t2.y;
				}
			}
		}

		if (mn == INF) {
			cout << "-1\n";
			//puts("-1");
		}
		else {
			cout << x1 + 1 << " " << y1 + 1 << " " << x2 + 1 << " " << y2 + 1 << "\n";
			//printf("%d %d %d %d\n", x1 + 1, y1 + 1, x2 + 1, y2 + 1);
		}
	}

	return 0;
}

