#include <string>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

void expand(vector<int> &v, int l, int mod) {
	for (int i = v.size(); i < l; i++) {
		int t2 = v.back(), t1 = v[v.size() - 2];
		v.push_back((t1 * 10007 + t2 * 10009 + 87277) % mod);
	}
}

void read(vector<int> &v) {
	int k;
	cin >> k;
	v.resize(k);
	for (auto& i : v) cin >> i;
}

long main() {
	ios::sync_with_stdio(0);
	int h, w, n;
	cin >> h >> w >> n;
	string ty;
	cin >> ty;
	vector<int> a, b, c, d;
	read(a);
	read(b);
	read(c);
	read(d);
	expand(a, n, h);
	expand(b, n, w);
	expand(c, n, h);
	expand(d, n, w);

	vector<vector<int>> v(h, vector<int>(w, 0));
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			v[i][j] = i * w + j;
		}
	}

	vector<int> hp(h), wp(w); // stroki i stolbci
	for (int i = 0; i < h; i++)
		hp[i] = i;
	for (int i = 0; i < w; i++)
		wp[i] = i;

	for (int i = 0; i < n; i++) {
		if (ty[i] == 'r')
			swap(hp[a[i]], hp[c[i]]);
		if (ty[i] == 'c')
			swap(wp[b[i]], wp[d[i]]);
		if (ty[i] == 'f')
			swap(v[hp[a[i]]][wp[b[i]]], v[hp[c[i]]][wp[d[i]]]);
	}

	const long long mod = 1e9 + 7;
	vector<long long> p17(h);
	p17[0] = 1;
	for (int i = 1; i < h; i++)
		p17[i] = p17[i - 1] * 17 % mod;
	vector<long long> p19(w);
	p19[0] = 1;
	for (int i = 1; i < w; i++)
		p19[i] = p19[i - 1] * 19 % mod;

	long long sum = 0;
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			sum = (sum + ((v[hp[i]][wp[j]] * p17[i]) % mod) * p19[j]) % mod;
		}
	}

	cout << sum;

	return 0;
}